! In this example a dataset is created, with
! three tables.
!
! The created datanew is then copied to a new dataset.

! A simple loop then iterates over the
! dataset's blocks (a table may be treated as a block)
! Each block is copyied to a second dataset, and
! then displays the name of each new block (which actually
! will be the same name as the source block); a comment
! is added to each new block.
program example_copyblock

  use dal
  
  implicit none

  type(DataSetT) set1, set2
  type(TableT) tab
  type(BlockT) blk
  integer i

  set1 = dataSet("test.dat",CREATE)
  tab = addTable(set1,"first table",100)
  tab = addTable(set1,"second table",1000)
  tab = addTable(set1,"third table",10000)

  set2 = dataSet("test1.dat",CREATE)

  do i = 0, numberOfBlocks( set1 ) - 1
    blk = block( set1, i, MODIFY )
    call copyBlock( set2, blk )
    blk = block( set2, i, MODIFY )
    call addComment( blk, "Copied from test.dat" )
  end do

  call release(set1)
  call release(set2)

end program example_copyblock
