! This example demonstrates the dimensions inteferface.

subroutine fillWithData( dataSetName )

  use dal

  implicit none

  character(len=*), intent(in) :: dataSetName
  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer(kind=INT32), dimension(:,:,:,:,:), pointer :: c
  integer, dimension(:), pointer :: s
  integer :: i,j,k,l,m,n

  ! Reopen dataset and fill with data.
  set = dataSet( dataSetName, MODIFY )
  tab = table( set, "table" )
  col = column( tab, "column", MODIFY )
  s => dimensions( col )
  c => int32Array4Data( col )

  n = 0
  do m=0,numberOfRows(tab) - 1
    do l=0, s(3) - 1
      do k=0, s(2) - 1
        do j=0, s(1) - 1
          do i=0, s(0) - 1
            c(i,j,k,l,m) = n
            n = n + 1
          end do
        end do
      end do
    end do
  end do

  call release(col)
  call release(set)

end subroutine fillWithData

program example_dimensions

  use dal

  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer, dimension(4), parameter :: s = (/ 3,4,5,6 /)

  ! create a set
  set = dataSet("test.dat",CREATE)
  tab = addTable(set, "table", 100, "table comment" )
  col = addColumn( tab, "column", INTEGER32, "km", s, "column comment" )
  call release( set )

  call fillWithData( "test.dat" )

end program example_dimensions
