! This example shows how the parent interface
! is used.
subroutine test1( set, tab, arr, col )

  use dal

  type(DataSetT), intent(in) :: set
  type(TableT), intent(in) :: tab
  type(ArrayT), intent(in) :: arr
  type(ColumnT), intent(in) :: col
  type(AttributeT) att



  att = attribute( set,0 )
  write(*,*) name( parent( att ))
  if( name( parent( att )) /= name( set )) then
	call error('internalError',"problem in parent method" )
  end if

  att = attribute( tab,0 )
  write(*,*) name( parent( att ))
  if( name( parent( att )) /= name( tab )) then
	call error('internalError',"problem in parent method" )
  end if

  write(*,*) name( parent( tab ))
  if( name( parent( tab )) /= name( set )) then
	call error('internalError',"problem in parent method" )
  end if

  att = attribute( arr,0 )
  write(*,*) name( parent( att ))
  if( name( parent( att )) /= name( arr )) then
	call error('internalError',"problem in parent method" )
  end if

  write(*,*) name( parent( arr ))

  if( name( parent( arr )) /= name( set )) then
	call error('internalError',"problem in parent method" )
  end if

  att = attribute( col,0 )
  write(*,*) name( parent( att ))
  if( name( parent( att )) /= name( col )) then
	call error('internalError',"problem in parent method" )
  end if

  write(*,*) name( parent( col ))

  if( name( parent( col )) /= name( tab )) then
	call error('internalError',"problem in parent method" )
  end if

  write(*,*) name( parent( parent( col )))

  if( name( parent( parent( col ))) /= name( set )) then
	call error('internalError',"problem in parent method" )
  end if

end subroutine test1


program example_parent

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  type(ArrayT) arr
  integer, dimension(3), parameter :: s = (/ 3,4,2 /)

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"sint8",1_int8,"int8 unit","set int8 comment")
  tab = addTable(set,"some table",100)
  call setAttribute(tab,"sint8",1_int8,"int8 unit","set int8 comment")
  arr = addArray(set, "some array", INTEGER32, dimensions=s )
  call setAttribute(arr,"sint8",1_int8,"int8 unit","set int8 comment")
  col = addColumn(tab,"bool",BOOLEAN)
  call setAttribute(col,"TLMIN",1_int8,"int8 unit","set int8 comment")

  call test1( set,tab,arr,col )

  call release(set)

  set = dataSet("test.dat",READ)
  tab = table(set,0)
  arr = array(set,1,READ)
  col = column(tab,0,READ)

  call test1( set,tab,arr,col )

  call release(set)

end program example_parent
