module autof90

use dal

type(ColumnDataT) xData, yData, rData

contains

  subroutine proc(st)
    type(SubTableT) :: st
    integer(kind=int16), dimension(:), pointer :: x,y
    real(kind=double), dimension(:), pointer :: r

    ! one could use data(st,"x") instead of xData
    x => int16Data(xData)
    y => int16Data(yData)
    r => real64Data(rData)
    write(*,*) x, y
    r = sqrt( sqr(x) + sqr(y) )
  end subroutine

  subroutine auto()
    type(DataSetT) set
    type(TableT) tab
    type(SubTableT) st

    set = dataSet("test.dat",MODIFY)
    tab = table(set,"events",MODIFY)
    st = subTable(tab)
    xData = addColumn(st,"x",READ)
    yData = addColumn(st,"y",READ)
    rData = addColumn(st,"r",CREATE)
    call forEachSubTable(st, proc)
    call release(set)
  end subroutine

end module
