#include <dal.h>
#include <stdio.h>
#include <math.h>

Column *xCol, *yCol, *rCol;

void proc(Table* tab)
{
  unsigned int i;
  int16*  x = int16Data(xCol);
  int16*  y = int16Data(yCol);
  real64* r = real64Data(rCol);
  for (i = 0; i < tableCount(tab); ++i) {
    printf("%hd %hd\n", x[i], y[i]);
    r[i] = sqrt( sqr(x[i]) * sqr(y[i]) );
  }
}

int main()
{
  DataSet *set;
  Table* tab;

  set = dataSet("test.dat",MODIFY);
  tab = table(set,"events",MODIFY);
  xCol = column(tab,"x",READ);
  yCol = column(tab,"y",READ);
  rCol = column(tab,"r",CREATE);
  forEachSubTable(tab,proc);
  dataSetRelease(set);
  return 0;
}

