using namespace std;
/*************************************************************** 
* 
* DalArray.cc & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Array. 
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalArray.cc,v 1.2 2004/03/05 14:43:00 eojero Exp $
* 
*****************************************************************/ 


#include "Tracer.h"


#include "DalArray.h"


DalArray::DalArray(
		const string &			name,
		DataType			dataType,
		const longVec&			size,
		const string &			units,
		const string &			label,
		DalDataSet *			parent )
	:
		DalBlock( name, Block::ArrayT, label, parent ),
		DalDataComponent( dataType, size, units, this )
{
	PROC
	ENDPROC
}


ArrayData *
DalArray::data(
		const longVec &			/*from = zero*/,
		const longVec &			/*count = zero*/,
		AccessMode			accessMode/*=AsParent*/ ) const
{
	PROC
	ArrayData* newArrayData = makeArrayData( accessMode );
	_dataObjects.push_back( newArrayData );
	RETURN newArrayData;

}


