//  Giuseppe Vacanti (cosine science & computing bv)
//  September 12, 2002
// 
//   $Id: DataSetRecord.cc,v 1.2 2004/03/05 14:43:02 eojero Exp $

#include<DataSetRecord.h>
#include<errstr.h>

DataSetRecord::DataSetRecord(const std::string & name)
    : name_(name),
      keep_(false),
      set_(0),
      count_(0),
      model_(DataSetServer::UseEnvironment)
{}

void DataSetRecord::dataSet(DataSet * set){
    set_ = set;
    ++(*this);
}

DataSet * DataSetRecord::dataSet() const{
    return set_;
}

Dal::AccessMode DataSetRecord::mode() const{
    if(! active())
	errstr << "The dataset " << name_ << " is not active"
	       << Sas::error("DataSetNonActive");
    return set_->mode();
}

DataSetServer::MemoryModel DataSetRecord::model() const{
    return model_;
}

void DataSetRecord::model(DataSetServer::MemoryModel model){
    model = model_;
}

DataSetRecord & DataSetRecord::operator++(){
    ++count_;
    return *this;
}
 
// DataSetRecord DataSetRecord::operator++(int){
//     DataSetRecord old(*this);
//     ++*this;
//     return old;
// }

DataSetRecord & DataSetRecord::operator--(){
    --count_;
    return *this;
}
 
// DataSetRecord DataSetRecord::operator--(int){
//     DataSetRecord old(*this);
//     --*this;
//     return old;
// }
   
unsigned long DataSetRecord::count() const{
    return count_;
}

bool DataSetRecord::keep() const{
    return keep_;
}

void DataSetRecord::keep(bool keep){
    keep_ = keep;
}

bool DataSetRecord::active() const{
    return set_ != 0;
}

const string & DataSetRecord::name() const {
    return name_;
}


