//  Giuseppe Vacanti (cosine science & computing bv)
//  September 12, 2002
// 
//   $Id: DataSetRecord.h,v 1.2 2004/03/05 14:43:02 eojero Exp $
#ifndef DATASETRECORD_H
#define DATASETRECORD_H

class DataSet;
#include<string>
#include<Dal.h>

// A reference-counted pointer to datasets.

class DataSetRecord {

public:
    DataSetRecord(const std::string & name);

    ~DataSetRecord() {}

    void dataSet(DataSet * set);
    DataSet * dataSet() const;

    Dal::AccessMode mode() const;
//    void mode(Dal::AccessMode mode);

    DataSetServer::MemoryModel model() const;
    void model(DataSetServer::MemoryModel model);

    DataSetRecord & operator++(); // prefix
//    DataSetRecord operator++(int); // postfix

    DataSetRecord & operator--(); // prefix
//    DataSetRecord operator--(int); // postfix

    unsigned long count() const;
    
    bool keep() const;
    void keep(bool keep);

    bool active() const;

    const std::string & name() const;

private:

    DataSetRecord(const DataSetRecord &);
    DataSetRecord & operator=(const DataSetRecord &);

    std::string name_;
    bool keep_;
    DataSet * set_;
    unsigned long count_;
    DataSetServer::MemoryModel model_;

};

#endif
