//  Giuseppe Vacanti (cosine science & computing bv)
//  September 13, 2002
// 
//   $Id: DataSetTracker.h,v 1.2 2004/03/05 14:43:02 eojero Exp $

#ifndef DATASETTRACKER_H
#define DATASETTRACKER_H

class DataSetRecord;

#include<map>
#include<string>
#include<iosfwd>

class DataSetTracker {
public:
    DataSetTracker();
    ~DataSetTracker();
    DataSetRecord & make_record(std::string const & name);
    DataSetRecord & get_record(std::string const & name) const;
    bool has_record(std::string const & name) const;
    unsigned long count() const;
    void printOn(ostream & os) const;

    typedef std::map<std::string, DataSetRecord *>::const_iterator const_iterator;
    typedef std::map<std::string, DataSetRecord *>::iterator iterator;
    iterator begin();
    const_iterator begin() const;
    iterator end();
    const_iterator end() const;



private:
    DataSetTracker(DataSetTracker const &);
    DataSetTracker & operator=(DataSetTracker const &);

    std::map<std::string, DataSetRecord *> db_;
};

// ostream & operator<<(ostream & os, const DataSetTracker & dst){
//     dst.printOn(os);
//     return os;
// }
    
#endif
