using namespace std;

#include<cassert>
#include <Dal.h>
//#include <ExceptionErrorHandler.h>
//#include <errstr.h>


int main()
{
  // *************************
  // Install exception handler
  // *************************
  //ExceptionErrorHandler local;
  //ErrorHandler* oldHandler = errHandler.handler(&local);
  //errHandler.name("ThisTestProgram");

  assert( dataSetServer -> client() == "" );
  DataSet * set = dataSetServer->open("test.dat",DataSet::Create);
  dataSetServer->close(set);
  assert( dataSetServer -> exists( "test.dat" ));
  assert( dataSetServer -> client() == "" );
  dataSetServer -> remove( "test.dat" );
  assert( !dataSetServer -> exists( "test.dat" ));
  assert( dataSetServer -> client() == "" );

  dataSetServer -> client( "CLIENT1" );
  assert( dataSetServer -> client() == "CLIENT1" );
  dataSetServer -> client( "CLIENT2" );
  assert( dataSetServer -> client() == "CLIENT2" );

  // Set the client, create a dataset, and then cleanup
  // the client.
  dataSetServer -> client( "CLIENT1" );
  assert( dataSetServer -> client() == "CLIENT1" );

  set = dataSetServer->open("test.dat",DataSet::Create);
  dataSetServer->close(set);
  assert( dataSetServer -> exists( "test.dat" ));
  assert( dataSetServer -> client() == "CLIENT1" );

  dataSetServer -> cleanupClient( "CLIENT1" );

  assert( dataSetServer -> exists( "test.dat" ));
  assert( dataSetServer -> client() == "CLIENT1" );

  set = dataSetServer->open("test.dat",DataSet::Create);
  dataSetServer -> cleanupClient( "CLIENT1" );
  // The following would fail (probably with a pure virtual called
  // error).
  // dataSetServer->close(set);
  
  //errHandler.handler(oldHandler); // return to default error handler

  return 0;
}
