using namespace std;
#include<cassert>
#include <Dal.h>

int main()
{
  DataSet *set = dataSetServer->open("test.dat",DataSet::Create);
  Table *tab = set->addTable("someTable",0);

  tab->addColumn("bool",Column::Bool);
  tab->addColumn("int8",Column::Int8);
  tab->addColumn("int16",Column::Int16);
  tab->addColumn("int32",Column::Int32);
  tab->addColumn("real32",Column::Real32);
  tab->addColumn("real64",Column::Real64);
  //tab->addColumn("string",Column::DString);

  unsigned n = 0;
  for (unsigned i = 0; i < 10; ++i) {
    tab->insertRows(i,i);
    n += i;
    assert( tab->rows() == n );
  }

  for (unsigned i = 0; i < 5; ++i) {
    tab->deleteRows(i,i);
    n -= i;
    assert( tab->rows() == n );
  }

  dataSetServer->close(set);

  return 0;
}

