using namespace std;
#include<cassert>

#include <Dal.h>
#include <errstr.h>
#include "StopWatch.h"

void
test()
{

  //char* dummy = new char[ 15000000 ];
  //delete[] dummy;

  DataSet *set = dataSetServer->open("test.dat",DataSet::Create);

  unsigned long size[] = { 4096,4096,1 };

  Array* arr;
  Data* data;
  real64* r64;

  //char* dummy = new char[ 15000000 ];
  //delete[] dummy;
  arr = set->addArray("real64Array", Array::Real64,
	vector<unsigned long>(size,size+3));
  data = arr->data();
  r64 = data->real64Data();
  for (unsigned i = 0; i < data->elements(); ++i)
   r64[i] = 0.25*i;
  delete data;

  char* dummy = new char[ 15000000 ];
  delete[] dummy;

  dataSetServer->close(set);


  set = dataSetServer->open("test.dat",DataSet::Read);
  arr = set->array("real64Array");
  assert( arr->dataType() == Array::Real64 );
  assert( arr->size() == vector<unsigned long>(size,size+3) );
  assert( arr->elements() == size[0]*size[1]*size[2] );
  data = arr->data();
  r64 = data->real64Data();
  for (unsigned i = 0; i < data->elements(); ++i)
   assert( r64[i] == 0.25*i );
  delete data;

  dataSetServer->close(set);

  set = dataSetServer->open("test.dat",DataSet::Modify);
  arr = set->array("real64Array");
  assert( arr->dataType() == Array::Real64 );
  assert( arr->size() == vector<unsigned long>(size,size+3) );
  assert( arr->elements() == size[0]*size[1]*size[2] );
  data = arr->data();
  r64 = data->real64Data();
  for (unsigned i = 0; i < data->elements(); ++i)
    assert( r64[i] == 0.25*i );
  delete data;

  dataSetServer->close(set);

}


int
main()
{
	// *********************************
	// Get clock for timing information.
	// *********************************
	StopWatch		cpuWatch( StopWatch::CPU );
	StopWatch		calenderWatch( StopWatch::Calender );


	for( unsigned int i = 0; i < 10; ++i )
	{
		test();
		cout << "[" << i << "] CPU time: " << cpuWatch.elapsed() << " secs" << endl;
		cout << "[" << i << "] Calender time: " << calenderWatch.elapsed() << " secs" << endl;
	} // for
	return 0;
}

