program arraytestcheck

  use dal
  use errorHandling

  implicit none

  type(DataSetT) :: set
  type(ArrayT) :: arr
  integer(kind=int32), dimension(:,:), pointer :: a
  integer i,j,n

  set = dataSet("arraytest.fits",read)

  arr = array(set,0,read)

  a => int32Array2Data(arr)

  write(*,*) shape(a)
  write(*,*) a

  if ( any(shape(a) /= (/ 2,3 /)) ) then
    write(errstr,*) "shape",shape(a),"but expected 2,3"
    call error("internalError")
  end if

  if ( a(0,0) /= 1 .or. a(1,0) /= 2 .or. a(0,1) /= 3 &
    .or. a(1,1) /= 4 .or. a(0,2) /= 5 .or. a(1,2) /= 6) &
    call error("internalError","value wrong")

  call release(set)

  set = dataSet("arraytest1.fits",create)
  arr = addArray(set,"test",integer32,(/ 2,3 /))
  a => int32Array2Data(arr)
  n = 1
  do j=0,2
    do i=0,1
      a(i,j) = n
      n = n + 1
    end do
  end do
  call release(set)

end program
