! This subroutine will write the contents of column 'x' to standard output.
module foreachrow1

  use dal
  use errorhandling

contains

  subroutine main()

    ! This part of the program will apply reportX to a table. 
    type(DataSetT) :: set
    type(TableT) :: tab
    type(ColumnT) :: xCol
    real(single), dimension(:), pointer :: x

    set = dataSet("test.dat",CREATE)
    tab = addTable(set,"events",1024)
    xCol = addColumn(tab,"x",real32,"mm")
    x => real32Data(xCol)
    x = 3

    call forEachRow(tab,proc)
  
    call release(tab)
    call release(set)

  end subroutine

  subroutine proc(tab)
    use dal
    use errorhandling

    type(TableT), intent(in) :: tab

    type(ColumnT) :: xCol
    real(kind=single), dimension(:), pointer :: x

    xCol = column(tab,"x",READ)
    x => real32Data(xCol)
    if (x(0) /= 3.0) call error("","wrong value in column")
    write(*,*) x

  end subroutine proc

end module foreachrow1
